#include <string.h>
#include <iostream>
#include <fstream>
using namespace std;

const int MAXS = 100;

const int NUMC = 5;
const int NUMR = 4;

const float prezzoOmbr = 10.0f;
const float prezzoSdraio = 6.5f;

struct Postazione {
  bool occupata;
  char nome[MAXS];
  bool ombrellone;
  int numSdraio;
};

struct Stabilimento {
  char nomeStab[MAXS];
  Postazione pos[NUMR][NUMC];
};

void stampaMappa(const Stabilimento* ps) ;
float incasso(const Stabilimento* ps) ;
bool arrivo(Stabilimento* ps, const char n[], bool o, int s) ;
bool partenza(Stabilimento* ps, const char n[]) ;
bool piuVicino(const Stabilimento* ps, int r, int c, int* pr, int* pc) ;

void carica(Stabilimento* ps) {
  char n[MAXS];
  char om;
  int sd;
  fstream ff;
  ff.open("input.txt", ios::in);
  while(ff >> n >> om >> sd)
    arrivo(ps, n, om == 'S', sd);
  ff.close();
}

void menu(){
  cout << "----------------" << endl;
  cout << "1) carica" << endl;
  cout << "2) stampa mappa" << endl;
  cout << "3) incasso" << endl;
  cout << "4) partenza" << endl;
  cout << "5) piu' vicino" << endl;
  cout << "6) esci" << endl;
  cout << "scelta? ";
}

void init(Stabilimento* ps){
  strcpy(ps->nomeStab, "Bagno Maestrale");
  for(int i=0; i<NUMR; i++)
    for(int j=0; j<NUMC; j++)
      ps->pos[i][j].occupata = false;
}

int main(){
  Stabilimento s;
  char c;
  float f;
  char n[MAXS];
  bool b;
  int rig, col, r1, c1;
  init(&s);
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        carica(&s);
        break;
      case '2':
        stampaMappa(&s);
        break;
      case '3':
        f = incasso(&s);
        cout << "L'incasso e' " << f << endl;
        break;
      case '4':
        cout << "inserisci il nome di chi parte: ";
        cin >> n;
        b = partenza(&s, n);  
        cout << (b ? "Partenza eseguita\n" : "Non trovato\n");
        break;
      case '5':
        cout << "Inserisci riga e colonna: ";
        cin >> rig >> col;
        b = piuVicino(&s, rig, col, &r1, &c1);
        if(!b) cout << "Piu' vicino ha restituito false" << endl;
        else cout << "Il posto libero piu' vicino e' " << r1 << " " << c1 << endl;
        break;
      case '6':
        return 0;
      default:
        cout << "Scelta non valida" << endl;
    }
  }
} 
