#include <string.h>
#include <iostream>
#include <fstream>
using namespace std;

const int MAXS = 100;

const int NUMC = 5;
const int NUMR = 4;

const float prezzoOmbr = 10.0f;
const float prezzoSdraio = 6.5f;

struct Postazione {
  bool occupata;
  char nome[MAXS];
  bool ombrellone;
  int numSdraio;
};

struct Stabilimento {
  char nomeStab[MAXS];
  Postazione pos[NUMR][NUMC];
};

void stampaMappa(const Stabilimento* ps) {
  cout << ps->nomeStab << endl;
  for(int i=0; i<NUMR; i++) {
    for(int j=0; j<NUMC; j++){
      if(ps->pos[i][j].occupata) {
        if(ps->pos[i][j].ombrellone) cout << 'O'; else cout << 'X';
        cout << ps->pos[i][j].numSdraio;
      }
      else
        cout << "  ";
      cout << '\t'; 
      }
    cout << endl;
  }
}

float incasso(const Stabilimento* ps) {
  float tot = 0;
  for(int i=0; i<NUMR; i++)
    for(int j=0; j<NUMC; j++)
      if(ps->pos[i][j].occupata)
        tot += ps->pos[i][j].numSdraio*prezzoSdraio + (ps->pos[i][j].ombrellone ? prezzoOmbr : 0);
  return tot;
}

bool arrivo(Stabilimento* ps, const char n[], bool o, int s) {
  for(int i=0; i<NUMR; i++)
    for(int j=0; j<NUMC; j++)
      if(!ps->pos[i][j].occupata) {
        ps->pos[i][j].occupata = true;
        strcpy(ps->pos[i][j].nome, n);
        ps->pos[i][j].ombrellone = o;
        ps->pos[i][j].numSdraio = s;  
        return true;
      }
  return false;
}

void cerca(const Stabilimento* ps, const char n[], int* pr, int* pc) {
  for(int i=0; i<NUMR; i++)
    for(int j=0; j<NUMC; j++)
      if(ps->pos[i][j].occupata && strcmp(ps->pos[i][j].nome, n) == 0) {
        *pr = i; *pc = j;
        return;
      }      
  *pc = *pr = -1;
}

bool partenza(Stabilimento* ps, const char n[]) {
  int r, c;
  cerca(ps, n, &r, &c);
  if(r == -1) return false;
  int i;
  for(i=r; i<NUMR-1 && ps->pos[i+1][c].occupata; i++){
    ps->pos[i][c] = ps->pos[i+1][c];
  }
  ps->pos[i][c].occupata = false;
  return true;
}

bool piuVicino(const Stabilimento* ps, int r, int c, int* pr, int* pc) {
  int max = NUMR > NUMC ? NUMR : NUMC;
  for(int cornice = 1; cornice<max; cornice++) {
    int i = r-cornice;
    int j = c-cornice;
    for(; i<=r+cornice; i++)
      if(i>=0 && j>=0 && i<NUMR && j<NUMC && !ps->pos[i][j].occupata) {
        *pr = i;
        *pc = j;
        return true;
      }
    for(;j<=c+cornice; j++)
       if(i>=0 && j>=0 && i<NUMR && j<NUMC && !ps->pos[i][j].occupata) {
        *pr = i;
        *pc = j;
        return true ;
      }
    for(; i>=r-cornice; i--)
     if(i>=0 && j>=0 && i<NUMR && j<NUMC && !ps->pos[i][j].occupata) {
        *pr = i;
        *pc = j;
        return true;
      }
    for(; j>=c-cornice; j--)
     if(i>=0 && j>=0 && i<NUMR && j<NUMC && !ps->pos[i][j].occupata) {
        *pr = i;
        *pc = j;
        return true;
      }
    if(cornice == max)
      return false;
  }
}

